{$APPTYPE CONSOLE}

program DemoAudioOutput;

uses
  SysUtils,
  Classes,
  PasLibVlcUnit in '..\..\source\PasLibVlcUnit.pas';

var
  args                         : packed array[0..2] of PAnsiChar;
  p_instance                   : libvlc_instance_t_ptr;
  vlc_audio_output_list        : libvlc_audio_output_t_ptr;
  vlc_audio_output_enum        : libvlc_audio_output_t_ptr;
  audio_output_list            : TStringList;
  audio_output_indx            : Integer;
  audio_output_device_count    : Integer;
  audio_output_device_index    : Integer;
  audio_output_device_longname : PAnsiChar;
  audio_output_device_id       : PAnsiChar;
begin
  try
    audio_output_list := TStringList.Create;
    libvlc_dynamic_dll_init();
    args[0] := PAnsiChar(libvlc_dynamic_dll_path);
    args[1] := NIL;//'--ignore-config';
    args[2] := NIL;
    p_instance := libvlc_new(1, @args);

    WriteLn('libvlc_audio_output_list_get');
    WriteLn;
    vlc_audio_output_list := libvlc_audio_output_list_get(p_instance);
    vlc_audio_output_enum := vlc_audio_output_list;
    while (vlc_audio_output_enum <> NIL) do
    begin
      audio_output_list.Add(vlc_audio_output_enum^.psz_name);
      WriteLn(' NAME = ', vlc_audio_output_enum^.psz_name);
      WriteLn(' DESC = ', vlc_audio_output_enum^.psz_description);
      WriteLn;
      vlc_audio_output_enum := vlc_audio_output_enum^.p_next;
    end;
    libvlc_audio_output_list_release(vlc_audio_output_list);
    WriteLn;

    WriteLn('libvlc_audio_output_device_count, libvlc_audio_output_device_longname');
    WriteLn;
    for audio_output_indx := 0 to audio_output_list.Count - 1 do
    begin
      audio_output_device_count := libvlc_audio_output_device_count(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]));
      WriteLn(audio_output_list.Strings[audio_output_indx], ': COUNT = ', audio_output_device_count);
      WriteLn;
      for audio_output_device_index := 0 to audio_output_device_count - 1 do
      begin
        audio_output_device_id       := libvlc_audio_output_device_id(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]), audio_output_device_index);
        audio_output_device_longname := libvlc_audio_output_device_longname(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]), audio_output_device_index);
        WriteLn('  IDX      = ', audio_output_device_index);
        WriteLn('  ID       = ', audio_output_device_id);
        WriteLn('  LONGNAME = ', StrPas(audio_output_device_longname));
        WriteLn;
        libvlc_free(audio_output_device_id);
      end;
    end;
    WriteLn;

    WriteLn('please try code');
    WriteLn;
    for audio_output_indx := 0 to audio_output_list.Count - 1 do
    begin
      audio_output_device_count := libvlc_audio_output_device_count(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]));
      for audio_output_device_index := 0 to audio_output_device_count - 1 do
      begin
        audio_output_device_id       := libvlc_audio_output_device_id(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]), audio_output_device_index);
        audio_output_device_longname := libvlc_audio_output_device_longname(p_instance, PAnsiChar(audio_output_list.Strings[audio_output_indx]), audio_output_device_index);
        WriteLn('// ', StrPas(audio_output_device_longname));
        WriteLn('libvlc_audio_output_set(p_mi,', '''', audio_output_list.Strings[audio_output_indx], '''', ');');
        WriteLn('libvlc_audio_output_device_set(');
        WriteLn('  p_mi,');
        WriteLn('  ', '''', audio_output_list.Strings[audio_output_indx], '''', ',');
        WriteLn('  ', '''', audio_output_device_id, '''', ');');
        WriteLn;
      end;
    end;

    ReadLn;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
